<template>
  <v-expand-transition>
    <v-card
      append
      v-show="formExpensesUnit"
      v-model="formExpensesUnit"
      class="ma-5"
    >
      <v-card-title outline>
        <v-toolbar-title>{{ title }}</v-toolbar-title>
        <v-spacer />

        <v-btn icon @click="formExpensesUnit = !formExpensesUnit">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-card-title>
      <v-divider class="mx-4"></v-divider>
      <form>
        <v-card-text>
          <v-text-field
            v-model="editedItem.name"
            label="ประเภทของต้นทุนค่าใช้จ่าย"
            :error-messages="nameErrors"
            required
            @input="$v.editedItem.name.$touch()"
            @blur="$v.editedItem.name.$touch()"
          >
          </v-text-field>
        </v-card-text>

        <v-card-actions>
          <v-spacer />
          <v-btn color="light-blue darken-2" dark>Clear</v-btn>
          <v-btn :color="btnCollo" dark @click="handdleAddData">
            {{ title }}
          </v-btn>
        </v-card-actions>
      </form>
    </v-card>
  </v-expand-transition>
</template>
<script>
import { validationMixin } from 'vuelidate'
import { required, minLength, maxLength, email } from 'vuelidate/lib/validators'

import Swal from 'sweetalert2'

export default {
  mixins: [validationMixin],

  validations: {
    editedItem: {
      name: {
        required,
      },
    },
  },

  props: ['findLastID', 'itemType'],

  data: () => ({
    btnCollo: 'success',
    indexEdit: -1,
    checkbox: false,

    editedItem: {
      id: null,
      name: '',
      auth: null,
    },
    defaultItem: {
      id: null,
      name: '',
      auth: null,
    },
  }),
  beforeCreate() {},
  computed: {
    // validate
    nameErrors() {
      const errors = []
      if (!this.$v.editedItem.name.$dirty) return errors
      !this.$v.editedItem.name.required &&
        errors.push('กรุณากรอกประเภทของค่าใช้จ่าย')
      return errors
    },

    formExpensesUnit: {
      get() {
        return this.$nuxt.$store.state.expensesunit.formExpensesUnit
      },
      set(newVal) {
        this.$store.commit('SET_FORM_EXPENSES_UNIT', newVal)
        // console.log('Edit Item', this.$nuxt.$store.state.expenseslist.EditItem)
      },
    },
    title() {
      this.indexEdit = this.$nuxt.$store.state.expensesunit.EditItem
      this.typeExpenseslist = this.itemType
      if (this.indexEdit === -1) {
        //เพิ่ม 2 (AddForm) การจัดการข้อความ "เพิ่มข้อมูล", ข้อความปุ่ม, สีปุ่ม
        this.btnCollo = 'success'
        this.putFormadddata()
        return 'เพิ่มข้อมูล'
      } else {
        //แก้ไข 2 (AddForm) การจัดการข้อความ "เพิ่มข้อมูล", ข้อความปุ่ม, สีปุ่ม
        this.putFormeditdata()
        this.btnCollo = 'warning'
        return 'แก้ไขข้อมูล'
      }
    },
  },

  updated() {
    // console.log('1')
  },
  methods: {
    putFormadddata() {
      //เพิ่ม 2.1 (AddForm) Set editItem ให้เป็นค่าว่าง พร้อมสำหรับกรอกข้อมูล
      this.editedItem = Object.assign({}, this.defaultItem)
    },
    putFormeditdata() {
      //แก้ไข 2.1 (AddForm) Set editItem จาก Parameter ที่ Commit เข้าใน Store จากนั้น ดึงค่าจาก Store โดยตรงมาใช้
      this.editedItem = Object.assign(
        {},
        this.$nuxt.$store.state.expensesunit.EditData
      )
      // this.checkSelect = Object.assign(
      //   {},
      //   this.$nuxt.$store.state.expenseslist.EditData.typeExpenses
      // )
      // Object.values(this.checkSelect).forEach((val) => {
      //   this.editedItem.selecterExpenses = val.id
      // })
    },
    handdleAddData() {
      // this.typeExpenses = this.editedItem.typeExpenses
      //เพิ่ม 2.2 (AddForm) Click เพิ่ม

      //ตรวจสอบการ Input ค่า ครบ,ถูก
      this.$v.$touch()
      if (this.$v.$invalid) {
        console.log('กรอกข้อมูลไม่ถูกต้อง หรือ ไม่ครบ')
      } else {
        this.editedItem.auth = this.$nuxt.$store.state.users.user.email
        if (this.indexEdit === -1) {
          // indexEdit != 1 (เพิ่ม)

          //เพิ่ม 2.3 (AddForm) Input ค่า ID, Email เข้าไปใน Edititem
          this.editedItem.id = this.findLastID

          //เพิ่ม 2.4 (AddForm) dispatch ไปยัง Fnc เพิ่มข้อมูล
          this.$store
            .dispatch('addDataExpensesUnit', {
              formVal: this.editedItem,
            })
            .then(() => {
              // เคลียร์ค่าว่าง
              this.editedItem = Object.assign({}, this.defaultItem)

              const Toast = Swal.mixin({
                toast: true,
                position: 'top',
                showConfirmButton: false,
                timer: 2000,
                timerProgressBar: true,
                didOpen: (toast) => {
                  toast.addEventListener('mouseenter', Swal.stopTimer)
                  toast.addEventListener('mouseleave', Swal.resumeTimer)
                },
              })

              Toast.fire({
                icon: 'success',
                title: 'บันทึกข้อมูลสำเร็จ',
              })

              //เพิ่ม 2.4.1 (AddForm) Set Commit จัดการหน้า Form สำหรับเพิ่มข้อมูล
              this.$store.commit('SET_FORM_EXPENSES_UNIT', false)
            })
            .catch((error) => {
              setTimeout(() => {
                console.log('Error In Cilent:', error.code)
              }, 2000)
            })
        } else {
          // indexEdit == 1 (แก้ไข)

          Swal.fire({
            title: 'คุณแน่ใจหรือไม่',
            text: 'คุณต้องการแก้ไขข้อมูลนี้',
            icon: 'question',
            showCancelButton: true,
            confirmButtonColor: '#FB8C00',
            cancelButtonColor: '#0288D1',
            confirmButtonText: 'ใช่, แก้ไขข้อมูล',
            cancelButtonText: 'ยกเลิก',
          }).then((result) => {
            if (result.isConfirmed) {
              Swal.fire(
                'แก้ไขข้อมูล',
                'คุณได้แก้ไขข้อมูลเรียบร้อยแล้ว',
                'success'
              )
              //แก้ไข 2.2 (AddForm) dispatch พร้อม parameter "this.editItem" ไปยัง Fnc เพิ่มข้อมูล
              this.$store
                .dispatch('editDataExpensesUnit', { formVal: this.editedItem })
                .then(() => {
                  //แก้ไข 2.2.1 (AddForm) Assign ค่าว่างเปล่าให้กับ "this.editemItem"
                  this.editedItem = Object.assign({}, this.defaultItem)
                  //แก้ไข 2.2.2 (AddForm) Set Commit จัดการหน้า Form สำหรับแก่ไขข้อมูล
                  this.$store.commit('SET_FORM_EXPENSES_UNIT', false)
                })
            }
          })
        }
      }
    },
  },
}
</script>
